from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, Float, File, String

Ssu_Cmstat_V0_1_0 = CommandToolBuilder(tool="ssu_cmstat", base_command=["ssu-cmstat"], inputs=[ToolInput(tag="in_configure_cm_glocal", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc=": configure CM for glocal alignment [default: local]")), ToolInput(tag="in_only_print_model", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc=": only print one line summary of model statistics  [default]")), ToolInput(tag="in_set_z_database", input_type=Int(optional=True), prefix="-Z", doc=InputDocumentation(doc=": set Z (database size in *Mb*) to <x> for E-value calculations")), ToolInput(tag="in_all", input_type=Boolean(optional=True), prefix="--all", doc=InputDocumentation(doc=": print model, E-value and filter thresholds stats")), ToolInput(tag="in_le", input_type=Boolean(optional=True), prefix="--le", doc=InputDocumentation(doc=": only print one line summary of  local E-value statistics")), ToolInput(tag="in_ge", input_type=Boolean(optional=True), prefix="--ge", doc=InputDocumentation(doc=": only print one line summary of glocal E-value statistics")), ToolInput(tag="in_beta", input_type=Float(optional=True), prefix="--beta", doc=InputDocumentation(doc=": set tail loss prob for QDB stats to <x>  [1E-7]  (0<x<1)")), ToolInput(tag="in_qdb_file", input_type=File(optional=True), prefix="--qdbfile", doc=InputDocumentation(doc=": save query-dependent bands (QDBs) for each state to file <f>")), ToolInput(tag="in_lfi", input_type=Boolean(optional=True), prefix="--lfi", doc=InputDocumentation(doc=": only print summary of  local Inside filter threshold stats")), ToolInput(tag="in_gfi", input_type=Boolean(optional=True), prefix="--gfi", doc=InputDocumentation(doc=": only print summary of glocal Inside filter threshold stats")), ToolInput(tag="in_lfc", input_type=Boolean(optional=True), prefix="--lfc", doc=InputDocumentation(doc=": only print summary of  local CYK    filter threshold stats")), ToolInput(tag="in_gfc", input_type=Boolean(optional=True), prefix="--gfc", doc=InputDocumentation(doc=": only print summary of glocal CYK    filter threshold stats")), ToolInput(tag="in_print_cmsearch_e", input_type=Int(optional=True), prefix="-E", doc=InputDocumentation(doc=": print HMM filter stats for cmsearch E cutoff <x>  (x>0)")), ToolInput(tag="in_cmsearch_cmsearch_bit", input_type=String(optional=True), prefix="-T", doc=InputDocumentation(doc=": print HMM filter stats for cmsearch bit cutoff <x>")), ToolInput(tag="in_nc", input_type=Boolean(optional=True), prefix="--nc", doc=InputDocumentation(doc=": print HMM filter stats for Rfam NC cutoff")), ToolInput(tag="in_ga", input_type=Boolean(optional=True), prefix="--ga", doc=InputDocumentation(doc=": print HMM filter stats for Rfam GA cutoff")), ToolInput(tag="in_tc", input_type=Boolean(optional=True), prefix="--tc", doc=InputDocumentation(doc=": print HMM filter stats for Rfam TC cutoff")), ToolInput(tag="in_seq_file", input_type=File(optional=True), prefix="--seqfile", doc=InputDocumentation(doc=": compute E-value cutoffs for sequence file <f>")), ToolInput(tag="in_top_only", input_type=Boolean(optional=True), prefix="--toponly", doc=InputDocumentation(doc=": with --seqfile, only consider top-strand")), ToolInput(tag="in_search", input_type=Boolean(optional=True), prefix="--search", doc=InputDocumentation(doc=": do search timing experiments")), ToolInput(tag="in_wsearch_set_seed", input_type=Int(optional=True), prefix="-s", doc=InputDocumentation(doc=": w/--search, set RNG seed to <n> (if 0: one-time arbitrary seed)")), ToolInput(tag="in_cml", input_type=Int(optional=True), prefix="--cmL", doc=InputDocumentation(doc=": length of sequences for CM search stats")), ToolInput(tag="in_hmm_l", input_type=Int(optional=True), prefix="--hmmL", doc=InputDocumentation(doc=": length of sequences for CP9 HMM search stats")), ToolInput(tag="in_e_file", input_type=String(optional=True), prefix="--efile", doc=InputDocumentation(doc=": output HMM filter E-val cutoff vs CM E-val cutoff plots to <f>")), ToolInput(tag="in_b_file", input_type=String(optional=True), prefix="--bfile", doc=InputDocumentation(doc=": output HMM filter bit sc cutoff vs CM bit sc cutoff plots to <f>")), ToolInput(tag="in_s_file", input_type=String(optional=True), prefix="--sfile", doc=InputDocumentation(doc=": output predicted survival fraction vs CM cutoff plots to <f>")), ToolInput(tag="in_x_file", input_type=String(optional=True), prefix="--xfile", doc=InputDocumentation(doc=": output predicted xhmm (calcs * HMM) vs CM cutoff plots to <f>")), ToolInput(tag="in_a_file", input_type=String(optional=True), prefix="--afile", doc=InputDocumentation(doc=": output predicted acceleration vs CM cutoff plots to <f>")), ToolInput(tag="in_bits", input_type=Boolean(optional=True), prefix="--bits", doc=InputDocumentation(doc=": with --{s,x,a}file, plot CM bit score cutoffs not E-values")), ToolInput(tag="in_options", input_type=Boolean(optional=True), prefix="-options", doc=InputDocumentation(doc="")), ToolInput(tag="in_cm_file", input_type=String(), position=0, doc=InputDocumentation(doc=""))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Ssu_Cmstat_V0_1_0().translate("wdl", allow_empty_container=True)

